
/* Copyright (C) 2004 whoosh777@blueyonder.co.uk  All rights reserved.
  
  This software is provided AS-IS with no warranty, either express or
  implied.
  
  This software is distributed under license and may not be copied,
  modified or distributed except as expressly authorized under the terms
  of the license contained in the file whoosh_LICENSE in this distribution.
  
  For more information about licensing, please email 
  whoosh777@blueyonder.co.uk
  For information on commercial licensing, email whoosh777@blueyonder.co.uk

  sometimes I may be away from the internet for several weeks, if I am 
  on the internet then I respond quickly to emails,

  My GS813 homepage http://www.whoosh777.pwp.blueyonder.co.uk
*/

/*
if you want your changes to this file to be maintained by whoosh777@blueyonder.co.uk,

ie as I develop further the viewers that the improvements should propagate 
through, 

then you must email me and I will send the current source + 
allocate you a time slot where my own development is "frozen" + 
I will give you rules to be followed in order for your changes to become 
incorporated.

the rules for this are much stricter than AFPL's rules,
this is because this is work in progress,

note also that such changes then become my private property to 
 use however I wish, you can also do whatever you wish with these changes 
ie they split into 2 copies one belongs to me, one belongs to you,

*/

#include "rgb_to_ham8.h"

/* #include <turbo.h> */

/* minimum: */
#define m(x,y) ((x) < (y)? (x) : (y) )

/* maximum: */
#define M(x,y) ((x) > (y)? (x) : (y) )

/* distance: */
#define	d(x,y) ( (x)>(y)? (x-y) : (y-x ) )

/* difficult to remember: */
#define HAM_BLUE  	0x40
#define HAM_RED  	0x80
#define HAM_GREEN  	0xc0

#define LUM_RED		1 
#define LUM_GREEN	1
#define LUM_BLUE	1

#define LUM_MAX		 M( LUM_RED , M( LUM_GREEN , LUM_BLUE ) ) 
#define LUM_MIN		 m( LUM_RED , m( LUM_GREEN , LUM_BLUE ) ) 


struct ColorMap *viewport_colormap( struct ViewPort *v )
{
if( v )return( v->ColorMap ) ;
else return( 0 ) ;
}


struct ViewPort *screen_viewport( struct Screen *s )
{
if( s )return( &( s->ViewPort ) ) ;
else return( 0 ) ;
}

struct ColorMap *screen_colormap( struct Screen *s )
{
return
	( 
	viewport_colormap
		( 
		screen_viewport( s ) 
		) 
	) ;
}

struct Screen *window_screen( struct Window *w )
{
if( w )return( w->WScreen ) ;
else return( 0 );
}

struct ViewPort *window_viewport( struct Window *w )
{
return( screen_viewport( window_screen( w ) ) ) ;
}

struct ColorMap *window_colormap( struct Window *w )
{
return( screen_colormap( window_screen( w ) ) ) ;
}

/**************************************/

struct BitMap *rastport_bitmap( struct RastPort *rp )
{
if( rp==0 )return( 0 ) ;
return( rp->BitMap ) ;
}

struct RastPort *window_rastport( struct Window *w )
{
if( w==0 )return( 0 ) ;
else return( w->RPort ) ;
}

struct BitMap *window_bitmap( struct Window *w )
{
return( rastport_bitmap( window_rastport( w ) ) ) ;
}

struct RastPort *screen_rastport( struct Screen *screen)
{
if( screen==0 )return( 0 ) ;
else return( &(screen->RastPort) ) ;
}

struct BitMap *screen_bitmap( struct Screen *screen )
{
return( rastport_bitmap( screen_rastport( screen) ) ) ;
}

int bitmap_depth( struct BitMap *bm )
{
if( bm==0 )return( 0 ) ;
return( bm->Depth ) ;
}

int bitmap_bytewidth( struct BitMap *bm )
{
if( bm==0 )return( 0 ) ;
return( bm->BytesPerRow ) ;
}

int bitmap_height( struct BitMap *bm )
{
if( bm==0 )return( 0 ) ;
return( bm->Rows ) ;
}

/************************************/

void setgrays( struct Screen *screen )
{
int i ;
for( i = 0 ; i < 64 ; i++ )
	{
	int j ;
	
	j = i << ( 32 - 6 ) ;
	/*
	SetRGB32( &(w->WScreen->ViewPort)  , i , j , j , j ) ;
	*/
	/*
	  pre whoosh7jun04
	whoosh_SetRGB32CM( screen->ViewPort.ColorMap  , i , j , j , j ) ;
	*/
	whoosh_SetRGB32( &screen->ViewPort , i , j , j , j ) ;
	}
for(  ; i < 256 ; i++ )
	{
	int j ;
	
	j = 0 ;
	/*
	SetRGB32( &(w->WScreen->ViewPort)  , i , j , j , j ) ;
	*/
	/* whoosh7jun04 
	whoosh_SetRGB32CM( screen->ViewPort.ColorMap  , i , j , j , j ) ;
	*/
	whoosh_SetRGB32( &screen->ViewPort , i , j , j , j ) ;
	}
}

void set256grays( struct Screen *screen )
{
int i ;
for( i = 0 ; i < 256 ; i++ )
	{
	int j ;
	
	j = i << ( 32 - 8 ) ;
	
	/*
	SetRGB32( &(w->WScreen->ViewPort)  , i , j , j , j ) ;
	*/
	/* whoosh7jun04
	whoosh_SetRGB32CM( *//* w->WScreen *//* 
		screen->ViewPort.ColorMap  , i , j , j , j ) ;
	*/
	whoosh_SetRGB32( /* w->WScreen */ 
		&screen->ViewPort , i , j , j , j ) ;
	}
}

void set216( struct Screen *screen , int delta )
{
int R , G , B , index ;

if( delta + 215 > 255 ){ PutStr( "internal error set216()\n" ) ; }

for( R = 0 ; R < 6 ; R++ )
	{
	for( G = 0 ; G < 6 ; G++ ) 
		{
		for( B = 0 ; B < 6 ; B++ )
			{
			index = 36 * R + 6 * G + B + delta ;
			/* whoosh7jun04
			  whoosh_SetRGB32CM
				( 
				screen->ViewPort.ColorMap , index ,
				(51 * R)<<24 , (51 * G)<<24 , (51 * B)<<24 
				) ;
			*/
		        whoosh_SetRGB32
				( 
				&screen->ViewPort , index ,
				(51 * R)<<24 , (51 * G)<<24 , (51 * B)<<24 
				) ;
			}
		}
	}
}

void setbw( struct Screen *screen )
{
/*
SetRGB32( &(w->WScreen->ViewPort)  , 1 , 0 , 0 , 0 ) ;
SetRGB32( &(w->WScreen->ViewPort)  , 0 , 255<<24 , 255<<24 , 255<<24 ) ;
*/
/* whoosh7jun04
whoosh_SetRGB32CM( screen->ViewPort.ColorMap  , 1 , 0 , 0 , 0 ) ;
whoosh_SetRGB32CM( screen->ViewPort.ColorMap  , 0 , 255<<24 , 255<<24 , 255<<24 ) ;
*/
whoosh_SetRGB32( &screen->ViewPort , 1 , 0 , 0 , 0 ) ;
whoosh_SetRGB32( &screen->ViewPort , 0 , 255<<24 , 255<<24 , 255<<24 ) ;
}


#define		MAXWAIT 	6 

/* arrayp has width * xfactor bytes */

void bw_to_line( unsigned char *bw , int bitpos , int width , int xfactor , 
			unsigned char *arrayp , int zero , int one ) 
{
int i , j , bytepos , index , destpos ;
unsigned c , mask ;

bytepos = bitpos / 8 ;

	{
	/* 0 1 2 3 ... -> 1<<7 1<<6 1<<5 ... */
	mask = (bitpos & 7 ) ;	/* 0 1 2 3 ..7 0 1 */
	mask = 7 - mask ; 	/* 7 6 5     0 7 6 */
	mask = 1 << mask ; 	/* 1<<7 .... 1==1<<0 , 1<<7 */
	}

i = 0 ; destpos = 0 ; 
c = bw[ bytepos ] ;

while( 1 ) 
	{
	if( c & mask ) index = one ; 
	else index = zero ;
	
	for( j = 1 ; j <= xfactor ; j++ )
		{
		arrayp[ destpos++ ] = index ;
		}
	
	i++ ;
	
	if( i == width )break ;
	
	if( mask==1 )
		{ 
		mask = 1<<7 ; 
		bytepos++ ;
		c = bw[ bytepos ] ; 
		}
	else mask = mask >> 1 ;
	}
}

/* spos = row * width * 3  ; */
/* arrayp has width * xfactor bytes */
/* return new spos */
int rgb_to_216line( unsigned char *rgb , int spos , int width , int xfactor , 
			unsigned char *arrayp , int delta , struct Window *w , 
		unsigned int *remap ) 
{
int i , j , pos ;
unsigned r , g , b , R , G , B , index ;

pos = 0 ;

for( i = 0 ; i < width ; i++ )
	{
	r = rgb[ spos++ ] ;
	g = rgb[ spos++ ] ;
	b = rgb[ spos++ ] ;
	
	R = ( 2 * r + 51 )/ 102 ; 
	G = ( 2 * g + 51 )/ 102 ; 
	B = ( 2 * b + 51 )/ 102 ; 
	
	index = 36 * R + 6 * G + B + delta ;
	
		{
		if( remap && w )
			{
			int newindex ;
			newindex = remap[ index ] ;
			if( newindex==-1 )
				{
				newindex = ObtainBestPen(
					w->WScreen->ViewPort.ColorMap , 
					r<<24 , g<<24 , b<<24 , 
					OBP_Precision , PRECISION_EXACT ,
					TAG_DONE ) ;
				remap[ index ] = newindex ;
				if( newindex!=-1 )index = newindex ;
				}
			else index = newindex ;
			}
		for( j = 0 ; j < xfactor ; j++ )
			arrayp[ pos++ ] = index ;
		}
	}
return( spos ) ;
}

/* OpenScreenTags() needs: SA_Overscan , OSCAN_VIDEO, wrong!? */
/* spos = row * width * 3  ; */
/* arrayp has width * xfactor bytes */
/* return new spos */
int rgb_to_ham8line( unsigned char *rgb , int spos , int width , int xfactor , 
			unsigned char *arrayp , int rowno ) 
{
int initialbias , bias ;


int fi , pr , pg , pb , i ;
int r , g , b , rr , gg , bb , index , j , lastr , lastg , lastb ;
int drr , dgg , dbb , dcc , dr , dg , db , maxwait ;
							
fi = 0 ;
/*
maxwait = env_int( "whooshwait" , 0 ) ;
*/
maxwait = 0 ;
if( maxwait==0 )maxwait = MAXWAIT ;

pr = pg = pb = 0 ; /* irrelevant values */
lastr = lastg = lastb = 0 ;
/*
switch( initialbias )
	{
	case 0 : 
	case HAM_BLUE: 
		initialbias = HAM_RED ; 
	break ;


	case HAM_RED : 
		initialbias = HAM_GREEN ; 
	break ;

	case HAM_GREEN : 
		initialbias = HAM_BLUE ; 
	break ;
	}
*/
{
int mod ;
mod = rowno - 3 * (rowno/3 ) ;
switch( mod )
	{
	case 0 :
		initialbias = HAM_RED ; 
	break ;
	case 1 :
		initialbias = HAM_GREEN ; 
	break ;
	case 2 :
		initialbias = HAM_BLUE ; 
	break ;

	default :
		PutStr("harmless bug in ham8 code\n");
		initialbias = HAM_RED ; 
	break ;
	}
bias = initialbias ;
}
/* scan the actual width */
for( i = 0 ; i < width ; i++ )
	{
	/*
	int bias ;

	bias = HAM_RED ;
	*/
	r = rgb[ spos++ ] & ~3 ; 
	g = rgb[ spos++ ] & ~3 ; 
	b = rgb[ spos++ ] & ~3 ;
	
	/* rgb triplet to repeat xfactor times */
	/* :intelligently! we want nice colours */
				
	rr = gg = bb = (( r + g + b )/3) & ~3 ;
				
	drr = LUM_RED * d( r , rr ) ;
	dgg = LUM_GREEN * d( g , gg ) ;
	dbb = LUM_BLUE * d( b , bb ) ;
		
	/* distance error from palette colour */		

	dcc = drr +  dgg + dbb ;

	/* 
	pr , pg , pb hence dr , dg , db change 
	under xfactor, hence enclose into loop:
	*/
	
	/* above values are constant within this loop: */
	for( j = 0 ; j<xfactor ; j++ )
		{
		int dR , dG , dB , dm ;

		/*
		if( bias == HAM_RED )bias = HAM_GREEN ;
		else if( bias == HAM_GREEN )bias = HAM_BLUE ;
		else bias = HAM_RED ;
		*/
		
		dr = LUM_RED * 		d( r , pr ) ;
		dg = LUM_GREEN * 	d( g , pg ) ;
		db = LUM_BLUE * 	d( b , pb ) ;
	
		if( lastr + maxwait < fi )
			{ dr = 128 ;  }
		if( lastg + maxwait < fi )
			{ dg = 128 ; }
		if( lastb + maxwait < fi )
			{ db = 128 ; }
		
		/* if we change r, dR is approx colour distance from new pixel */

		dR = dg+db ; dG = dr + db ; dB = dr + dg ;

		/* minimize this error: */
		dm = m( m( dR , dG ) , dB ) ;
		
		/* if can achieve colour by HAM8 then dm==0 eg repeats! */
		if( dm > dcc || fi==0 )
			{
			if( fi==0 ){ index = 0 ; pr = pg = pb = 0 ; }
			else
				{
				index = rr >> 2 ;
				pr = rr ; pg = gg ; pb = bb ;
				}
			lastr = lastg = lastb = fi ;
			arrayp[ fi++ ] = index ;
			}	
		/* use HAM8 method? never happens at first pixel */
		else 
			{
			int c ;
			/* changed to true rotation due to lurid effects */
			/* true rotation is worse! */
			/* if( bias==HAM_RED ) */
			
			/* if wait too long, force change of component */
			/* not too bad! eg with maxwait==6:
			if( lastr + maxwait < fi )
				{ dm = dR = 0 ; dG = dB = 1 ; }
			else if( lastg + maxwait < fi )
				{ dm = dG = 0 ; dR = dB = 1 ; }
			else if( lastb + maxwait < fi )
				{ dm = dB = 0 ; dG = dR = 1 ; }
			*/
			if( dm==dR && (bias==HAM_RED || dm< dG && dm<dB ) )
				{ 
				c = r  >> 2 ;
				lastr = fi ;
				arrayp[ fi++ ] = HAM_RED + c ; 
				pr = c << 2 ;
				/* used to be unconditional */
				if( bias==HAM_RED && (dm==dG || dm==dB) )
					bias = HAM_GREEN ;
				}
			/* else if( bias==HAM_GREEN ) */
			else if( dm==dG && (bias==HAM_GREEN || dm<dB ) )
				{ 
				c = (g ) >> 2 ;
				lastg = fi ;
				arrayp[ fi++ ] = HAM_GREEN + c ; 
				pg = c << 2 ;
				if( bias==HAM_GREEN && dm==dB )bias = HAM_BLUE ;
				}
			else /* dm==dB */
				{ 
				c = (b ) >> 2 ;
				lastb = fi ;
				arrayp[ fi++ ] = HAM_BLUE + c ; 
				pb = c << 2 ;
				if( bias==HAM_BLUE )bias = HAM_RED ;
				}
			}/* ham8 else */
		}/* for < xfactor */
	}/* for < width */
return( spos ) ;
}

